Index: drivers/filesystems/btrfs/btrfs.c
===================================================================
--- drivers/filesystems/btrfs/btrfs.c	(révision 75772)
+++ drivers/filesystems/btrfs/btrfs.c	(copie de travail)
@@ -3159,65 +3180,98 @@
                                 done = TRUE;
                                 break;
                             }
-                            
+
                             le = le->Flink;
                         }
-                        
+
                         if (!done) {
-                            ERR("volume not found: device %llx, uuid %02x%02x%02x%02x-%02x%02x-%02x%02x-%02x%02x-%02x%02x%02x%02x%02x%02x\n", tp.item->key.offset,
-                            di->device_uuid.uuid[0], di->device_uuid.uuid[1], di->device_uuid.uuid[2], di->device_uuid.uuid[3], di->device_uuid.uuid[4], di->device_uuid.uuid[5], di->device_uuid.uuid[6], di->device_uuid.uuid[7],
-                            di->device_uuid.uuid[8], di->device_uuid.uuid[9], di->device_uuid.uuid[10], di->device_uuid.uuid[11], di->device_uuid.uuid[12], di->device_uuid.uuid[13], di->device_uuid.uuid[14], di->device_uuid.uuid[15]);
+                            if (!Vcb->options.allow_degraded) {
+                                ERR("volume not found: device %llx, uuid %02x%02x%02x%02x-%02x%02x-%02x%02x-%02x%02x-%02x%02x%02x%02x%02x%02x\n", tp.item->key.offset,
+                                    di->device_uuid.uuid[0], di->device_uuid.uuid[1], di->device_uuid.uuid[2], di->device_uuid.uuid[3], di->device_uuid.uuid[4], di->device_uuid.uuid[5], di->device_uuid.uuid[6], di->device_uuid.uuid[7],
+                                    di->device_uuid.uuid[8], di->device_uuid.uuid[9], di->device_uuid.uuid[10], di->device_uuid.uuid[11], di->device_uuid.uuid[12], di->device_uuid.uuid[13], di->device_uuid.uuid[14], di->device_uuid.uuid[15]);
+                            } else {
+                                device* dev;
+
+                                dev = ExAllocatePoolWithTag(NonPagedPool, sizeof(device), ALLOC_TAG);
+                                if (!dev) {
+                                    ExReleaseResourceLite(&pdode->child_lock);
+                                    ERR("out of memory\n");
+                                    return STATUS_INSUFFICIENT_RESOURCES;
+                                }
+
+                                RtlZeroMemory(dev, sizeof(device));
+
+                                // Missing device, so we keep dev->devobj as NULL
+                                RtlCopyMemory(&dev->devitem, di, min(tp.item->size, sizeof(DEV_ITEM)));
+                                InitializeListHead(&dev->trim_list);
+
+                                add_device_to_list(Vcb, dev);
+                                Vcb->devices_loaded++;
+                            }
                         }
                     } else
                         ERR("unexpected device %llx found\n", tp.item->key.offset);
-                    
-                    ExReleaseResourceLite(&volumes_lock);
+
+                    ExReleaseResourceLite(&pdode->child_lock);
                 }
             }
         } else if (tp.item->key.obj_type == TYPE_CHUNK_ITEM) {
             if (tp.item->size < sizeof(CHUNK_ITEM)) {
                 ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(CHUNK_ITEM));
-            } else {            
+            } else {
                 c = ExAllocatePoolWithTag(NonPagedPool, sizeof(chunk), ALLOC_TAG);
-                
+
                 if (!c) {
                     ERR("out of memory\n");
                     return STATUS_INSUFFICIENT_RESOURCES;
                 }
-                
+
                 c->size = tp.item->size;
                 c->offset = tp.item->key.offset;
                 c->used = c->oldused = 0;
-                c->cache = NULL;
+                c->cache = c->old_cache = NULL;
                 c->created = FALSE;
                 c->readonly = FALSE;
                 c->reloc = FALSE;
-                
+                c->cache_loaded = FALSE;
+                c->changed = FALSE;
+                c->space_changed = FALSE;
+                c->balance_num = 0;
+
                 c->chunk_item = ExAllocatePoolWithTag(NonPagedPool, tp.item->size, ALLOC_TAG);
-                
+
                 if (!c->chunk_item) {
                     ERR("out of memory\n");
                     ExFreePool(c);
                     return STATUS_INSUFFICIENT_RESOURCES;
                 }
-            
+
                 RtlCopyMemory(c->chunk_item, tp.item->data, tp.item->size);
-                
+
                 if (c->chunk_item->type & BLOCK_FLAG_DATA && c->chunk_item->type > Vcb->data_flags)
                     Vcb->data_flags = c->chunk_item->type;
-                
+
                 if (c->chunk_item->type & BLOCK_FLAG_METADATA && c->chunk_item->type > Vcb->metadata_flags)
                     Vcb->metadata_flags = c->chunk_item->type;
-                
+
                 if (c->chunk_item->type & BLOCK_FLAG_SYSTEM && c->chunk_item->type > Vcb->system_flags)
                     Vcb->system_flags = c->chunk_item->type;
-                
+
+                if (c->chunk_item->type & BLOCK_FLAG_RAID10) {
+                    if (c->chunk_item->sub_stripes == 0 || c->chunk_item->sub_stripes > c->chunk_item->num_stripes) {
+                        ERR("chunk %llx: invalid stripes (num_stripes %u, sub_stripes %u)\n", c->offset, c->chunk_item->num_stripes, c->chunk_item->sub_stripes);
+                        ExFreePool(c->chunk_item);
+                        ExFreePool(c);
+                        return STATUS_INTERNAL_ERROR;
+                    }
+                }
+
                 if (c->chunk_item->num_stripes > 0) {
                     CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&c->chunk_item[1];
                     UINT16 i;
-                    
+
                     c->devices = ExAllocatePoolWithTag(NonPagedPool, sizeof(device*) * c->chunk_item->num_stripes, ALLOC_TAG);
-                    
+
                     if (!c->devices) {
                         ERR("out of memory\n");
                         ExFreePool(c->chunk_item);
@@ -3224,11 +3278,11 @@
                         ExFreePool(c);
                         return STATUS_INSUFFICIENT_RESOURCES;
                     }
-                    
+
                     for (i = 0; i < c->chunk_item->num_stripes; i++) {
                         c->devices[i] = find_device_from_uuid(Vcb, &cis[i].dev_uuid);
                         TRACE("device %llu = %p\n", i, c->devices[i]);
-                        
+
                         if (!c->devices[i]) {
                             ERR("missing device\n");
                             ExFreePool(c->chunk_item);
@@ -3235,85 +3289,93 @@
                             ExFreePool(c);
                             return STATUS_INTERNAL_ERROR;
                         }
-                            
+
                         if (c->devices[i]->readonly)
                             c->readonly = TRUE;
                     }
-                } else
-                    c->devices = NULL;
-                
+                } else {
+                    ERR("chunk %llx: number of stripes is 0\n", c->offset);
+                    ExFreePool(c->chunk_item);
+                    ExFreePool(c);
+                    return STATUS_INTERNAL_ERROR;
+                }
+
                 ExInitializeResourceLite(&c->lock);
                 ExInitializeResourceLite(&c->changed_extents_lock);
-                
+
                 InitializeListHead(&c->space);
                 InitializeListHead(&c->space_size);
                 InitializeListHead(&c->deleting);
                 InitializeListHead(&c->changed_extents);
-                
+
                 InitializeListHead(&c->range_locks);
-                KeInitializeSpinLock(&c->range_locks_spinlock);
+                ExInitializeResourceLite(&c->range_locks_lock);
                 KeInitializeEvent(&c->range_locks_event, NotificationEvent, FALSE);
-                
+
+                InitializeListHead(&c->partial_stripes);
+                ExInitializeResourceLite(&c->partial_stripes_lock);
+
                 c->last_alloc_set = FALSE;
 
+                c->last_stripe = 0;
+
                 InsertTailList(&Vcb->chunks, &c->list_entry);
-                
-                c->list_entry_changed.Flink = NULL;
+
                 c->list_entry_balance.Flink = NULL;
             }
         }
-    
+
         b = find_next_item(Vcb, &tp, &next_tp, FALSE, Irp);
-        
+
         if (b)
             tp = next_tp;
     } while (b);
-    
+
     Vcb->log_to_phys_loaded = TRUE;
-    
+
     if (Vcb->data_flags == 0)
         Vcb->data_flags = BLOCK_FLAG_DATA | (Vcb->superblock.num_devices > 1 ? BLOCK_FLAG_RAID0 : 0);
-    
+
     if (Vcb->metadata_flags == 0)
         Vcb->metadata_flags = BLOCK_FLAG_METADATA | (Vcb->superblock.num_devices > 1 ? BLOCK_FLAG_RAID1 : BLOCK_FLAG_DUPLICATE);
-    
+
     if (Vcb->system_flags == 0)
         Vcb->system_flags = BLOCK_FLAG_SYSTEM | (Vcb->superblock.num_devices > 1 ? BLOCK_FLAG_RAID1 : BLOCK_FLAG_DUPLICATE);
-    
+
     if (Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_MIXED_GROUPS) {
         Vcb->metadata_flags |= BLOCK_FLAG_DATA;
         Vcb->data_flags = Vcb->metadata_flags;
     }
-    
+
     return STATUS_SUCCESS;
 }
 
-void protect_superblocks(device_extension* Vcb, chunk* c) {
+void protect_superblocks(_Inout_ chunk* c) {
     UINT16 i = 0, j;
     UINT64 off_start, off_end;
-    
+
     // The Linux driver also protects all the space before the first superblock.
-    // I realize this confuses physical and logical addresses, but this is what btrfs-progs does - 
+    // I realize this confuses physical and logical addresses, but this is what btrfs-progs does -
     // evidently Linux assumes the chunk at 0 is always SINGLE.
     if (c->offset < superblock_addrs[0])
-        space_list_subtract(Vcb, c, FALSE, c->offset, superblock_addrs[0] - c->offset, NULL);
-    
+        space_list_subtract(c, FALSE, c->offset, superblock_addrs[0] - c->offset, NULL);
+
     while (superblock_addrs[i] != 0) {
         CHUNK_ITEM* ci = c->chunk_item;
         CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&ci[1];
-        
+
         if (ci->type & BLOCK_FLAG_RAID0 || ci->type & BLOCK_FLAG_RAID10) {
             for (j = 0; j < ci->num_stripes; j++) {
-                ULONG sub_stripes = max(ci->sub_stripes, 1);
-                
+                UINT16 sub_stripes = max(ci->sub_stripes, 1);
+
                 if (cis[j].offset + (ci->size * ci->num_stripes / sub_stripes) > superblock_addrs[i] && cis[j].offset <= superblock_addrs[i] + sizeof(superblock)) {
 #ifdef _DEBUG
                     UINT64 startoff;
                     UINT16 startoffstripe;
 #endif
-                    
+
                     TRACE("cut out superblock in chunk %llx\n", c->offset);
-                    
+
                     off_start = superblock_addrs[i] - cis[j].offset;
                     off_start -= off_start % ci->stripe_length;
                     off_start *= ci->num_stripes / sub_stripes;
@@ -3320,50 +3382,52 @@
                     off_start += (j / sub_stripes) * ci->stripe_length;
 
                     off_end = off_start + ci->stripe_length;
-                    
+
 #ifdef _DEBUG
                     get_raid0_offset(off_start, ci->stripe_length, ci->num_stripes / sub_stripes, &startoff, &startoffstripe);
                     TRACE("j = %u, startoffstripe = %u\n", j, startoffstripe);
                     TRACE("startoff = %llx, superblock = %llx\n", startoff + cis[j].offset, superblock_addrs[i]);
 #endif
-                    
-                    space_list_subtract(Vcb, c, FALSE, c->offset + off_start, off_end - off_start, NULL);
+
+                    space_list_subtract(c, FALSE, c->offset + off_start, off_end - off_start, NULL);
                 }
             }
         } else if (ci->type & BLOCK_FLAG_RAID5) {
+            UINT64 stripe_size = ci->size / (ci->num_stripes - 1);
+
             for (j = 0; j < ci->num_stripes; j++) {
-                UINT64 stripe_size = ci->size / (ci->num_stripes - 1);
-                
                 if (cis[j].offset + stripe_size > superblock_addrs[i] && cis[j].offset <= superblock_addrs[i] + sizeof(superblock)) {
                     TRACE("cut out superblock in chunk %llx\n", c->offset);
-                    
+
                     off_start = superblock_addrs[i] - cis[j].offset;
-                    off_start -= off_start % (ci->stripe_length * (ci->num_stripes - 1));
+                    off_start -= off_start % ci->stripe_length;
                     off_start *= ci->num_stripes - 1;
 
-                    off_end = off_start + (ci->stripe_length * (ci->num_stripes - 1));
-                    
+                    off_end = sector_align(superblock_addrs[i] - cis[j].offset + sizeof(superblock), ci->stripe_length);
+                    off_end *= ci->num_stripes - 1;
+
                     TRACE("cutting out %llx, size %llx\n", c->offset + off_start, off_end - off_start);
 
-                    space_list_subtract(Vcb, c, FALSE, c->offset + off_start, off_end - off_start, NULL);
+                    space_list_subtract(c, FALSE, c->offset + off_start, off_end - off_start, NULL);
                 }
             }
         } else if (ci->type & BLOCK_FLAG_RAID6) {
+            UINT64 stripe_size = ci->size / (ci->num_stripes - 2);
+
             for (j = 0; j < ci->num_stripes; j++) {
-                UINT64 stripe_size = ci->size / (ci->num_stripes - 2);
-                
                 if (cis[j].offset + stripe_size > superblock_addrs[i] && cis[j].offset <= superblock_addrs[i] + sizeof(superblock)) {
                     TRACE("cut out superblock in chunk %llx\n", c->offset);
-                    
+
                     off_start = superblock_addrs[i] - cis[j].offset;
-                    off_start -= off_start % (ci->stripe_length * (ci->num_stripes - 2));
+                    off_start -= off_start % ci->stripe_length;
                     off_start *= ci->num_stripes - 2;
 
-                    off_end = off_start + (ci->stripe_length * (ci->num_stripes - 2));
-                    
+                    off_end = sector_align(superblock_addrs[i] - cis[j].offset + sizeof(superblock), ci->stripe_length);
+                    off_end *= ci->num_stripes - 2;
+
                     TRACE("cutting out %llx, size %llx\n", c->offset + off_start, off_end - off_start);
 
-                    space_list_subtract(Vcb, c, FALSE, c->offset + off_start, off_end - off_start, NULL);
+                    space_list_subtract(c, FALSE, c->offset + off_start, off_end - off_start, NULL);
                 }
             }
         } else { // SINGLE, DUPLICATE, RAID1
@@ -3370,22 +3434,22 @@
             for (j = 0; j < ci->num_stripes; j++) {
                 if (cis[j].offset + ci->size > superblock_addrs[i] && cis[j].offset <= superblock_addrs[i] + sizeof(superblock)) {
                     TRACE("cut out superblock in chunk %llx\n", c->offset);
-                    
+
                     // The Linux driver protects the whole stripe in which the superblock lives
 
                     off_start = ((superblock_addrs[i] - cis[j].offset) / c->chunk_item->stripe_length) * c->chunk_item->stripe_length;
                     off_end = sector_align(superblock_addrs[i] - cis[j].offset + sizeof(superblock), c->chunk_item->stripe_length);
-                    
-                    space_list_subtract(Vcb, c, FALSE, c->offset + off_start, off_end - off_start, NULL);
+
+                    space_list_subtract(c, FALSE, c->offset + off_start, off_end - off_start, NULL);
                 }
             }
         }
-        
+
         i++;
     }
 }
 
-static NTSTATUS STDCALL find_chunk_usage(device_extension* Vcb, PIRP Irp) {
+NTSTATUS find_chunk_usage(_In_ _Requires_lock_held_(_Curr_->tree_lock) device_extension* Vcb, _In_opt_ PIRP Irp) {
     LIST_ENTRY* le = Vcb->chunks.Flink;
     chunk* c;
     KEY searchkey;
@@ -3392,27 +3456,27 @@
     traverse_ptr tp;
     BLOCK_GROUP_ITEM* bgi;
     NTSTATUS Status;
-    
+
     searchkey.obj_type = TYPE_BLOCK_GROUP_ITEM;
-    
+
     while (le != &Vcb->chunks) {
         c = CONTAINING_RECORD(le, chunk, list_entry);
-        
+
         searchkey.obj_id = c->offset;
         searchkey.offset = c->chunk_item->size;
-        
+
         Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("error - find_item returned %08x\n", Status);
             return Status;
         }
-        
+
         if (!keycmp(searchkey, tp.item->key)) {
             if (tp.item->size >= sizeof(BLOCK_GROUP_ITEM)) {
                 bgi = (BLOCK_GROUP_ITEM*)tp.item->data;
-                
+
                 c->used = c->oldused = bgi->used;
-                
+
                 TRACE("chunk %llx has %llx bytes used\n", c->offset, c->used);
             } else {
                 ERR("(%llx;%llx,%x,%llx) is %u bytes, expected %u\n",
@@ -3420,75 +3484,18 @@
             }
         }
 
-        if (!Vcb->readonly) {
-            // It doesn't make a great deal of sense to load the free space cache of a
-            // readonly seeding chunk, as we'll never write to it. But btrfs check will
-            // complain if we don't write a valid cache, so we have to do it anyway...
-                
-            // FIXME - make sure we free occasionally after doing one of these, or we
-            // might use up a lot of memory with a big disk.
-            
-            Status = load_free_space_cache(Vcb, c, Irp);
-            if (!NT_SUCCESS(Status)) {
-                ERR("load_free_space_cache returned %08x\n", Status);
-                return Status;
-            }
-            
-            protect_superblocks(Vcb, c);
-        }
-
         le = le->Flink;
     }
-    
+
+    Vcb->chunk_usage_found = TRUE;
+
     return STATUS_SUCCESS;
 }
 
-// static void STDCALL root_test(device_extension* Vcb) {
-//     root* r;
-//     KEY searchkey;
-//     traverse_ptr tp, next_tp;
-//     BOOL b;
-//     
-//     r = Vcb->roots;
-//     while (r) {
-//         if (r->id == 0x102)
-//             break;
-//         r = r->next;
-//     }
-//     
-//     if (!r) {
-//         ERR("Could not find root tree.\n");
-//         return;
-//     }
-//     
-//     searchkey.obj_id = 0x1b6;
-//     searchkey.obj_type = 0xb;
-//     searchkey.offset = 0;
-//     
-//     if (!find_item(Vcb, r, &tp, &searchkey, NULL, FALSE)) {
-//         ERR("Could not find first item.\n");
-//         return;
-//     }
-//     
-//     b = TRUE;
-//     do {
-//         TRACE("%x,%x,%x\n", (UINT32)tp.item->key.obj_id, tp.item->key.obj_type, (UINT32)tp.item->key.offset);
-//         
-//         b = find_prev_item(Vcb, &tp, &next_tp, NULL, FALSE);
-//         
-//         if (b) {
-//             free_traverse_ptr(&tp);
-//             tp = next_tp;
-//         }
-//     } while (b);
-//     
-//     free_traverse_ptr(&tp);
-// }
-
-static NTSTATUS load_sys_chunks(device_extension* Vcb) {
+static NTSTATUS load_sys_chunks(_In_ device_extension* Vcb) {
     KEY key;
     ULONG n = Vcb->superblock.n;
-    
+
     while (n > 0) {
         if (n > sizeof(KEY)) {
             RtlCopyMemory(&key, &Vcb->superblock.sys_chunk_array[Vcb->superblock.n - n], sizeof(KEY));
@@ -3495,42 +3502,43 @@
             n -= sizeof(KEY);
         } else
             return STATUS_SUCCESS;
-        
+
         TRACE("bootstrap: %llx,%x,%llx\n", key.obj_id, key.obj_type, key.offset);
-        
+
         if (key.obj_type == TYPE_CHUNK_ITEM) {
             CHUNK_ITEM* ci;
-            ULONG cisize;
+            USHORT cisize;
             sys_chunk* sc;
-            
+
             if (n < sizeof(CHUNK_ITEM))
                 return STATUS_SUCCESS;
-            
+
             ci = (CHUNK_ITEM*)&Vcb->superblock.sys_chunk_array[Vcb->superblock.n - n];
             cisize = sizeof(CHUNK_ITEM) + (ci->num_stripes * sizeof(CHUNK_ITEM_STRIPE));
-            
+
             if (n < cisize)
                 return STATUS_SUCCESS;
-            
+
             sc = ExAllocatePoolWithTag(PagedPool, sizeof(sys_chunk), ALLOC_TAG);
-            
+
             if (!sc) {
                 ERR("out of memory\n");
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
-            
+
             sc->key = key;
             sc->size = cisize;
             sc->data = ExAllocatePoolWithTag(PagedPool, sc->size, ALLOC_TAG);
-            
+
             if (!sc->data) {
                 ERR("out of memory\n");
+                ExFreePool(sc);
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
-            
+
             RtlCopyMemory(sc->data, ci, sc->size);
             InsertTailList(&Vcb->sys_chunks, &sc->list_entry);
-            
+
             n -= cisize;
         } else {
             ERR("unexpected item %llx,%x,%llx in bootstrap\n", key.obj_id, key.obj_type, key.offset);
